; CALC.asm
 ;  by Jimmy Mrdell

 ;  Jim Macdonell jimm@snowline.net

 ;  and William Deich williamiv@geocities.com
 ;
 ;
 ;  OK world, this program has a fairy tail behind it.
 ;
 ;  	Once upon a time young programmer named Jim Macdonell wrote a
 ;  program called acid11 to help the rest of his chemistry class.
 ;  Later William Charles Deich IV, in Hollywood, Florida came along
 ;  and wanted to use the program to display math formulas, but
 ;  didn't know much ASM.  Therefore, Jimmy Mrdell, a nice young
 ;  programmer in Sweeden, greatly improved the code for him.
 ;  Finally, William picked out the math formulas for it to display.
 ;  This is why the program still calls the display stings "acids."
 ;

 ;  This version of the program displays formulas for BASIC MATH:
 ;  [Exponents, Arithmetic Operations, Logs, Equations, Graphs,  
 ;  Quadratic Equations, Geometry, Trigonometry]
 ;
 ;  You can add any number of display strings, or just change
 ;  the whole list of display strings as I did.  However, the

 ;  number of display strings must not be larger than 255.
 ;

 ;  Press any key (except EXIT or ON) and it flips to the next page.

 

NoAcids = $80DF 

 

 #include "TI-85.h"

  

 .org 0



 .db "MATH FORMULAS", 0

 

  ROM_CALL(CLEARLCD)

  ld hl,$0101

  ld ($8333),hl

  ld de,Header

  ld hl,(PROGRAM_ADDR)

  add hl,de

  ROM_CALL(D_ZM_STR)

 

  ld de,Acids

  ld hl,(PROGRAM_ADDR)

  add hl,de  

  ld b,0

CountAcids:

  ld a,(hl)

  or a

  jr z,CountDone

  ld c,-1

  xor a

  cpir

  inc b

  jr CountAcids

CountDone:

  ld a,b

  ld (NoAcids),a

    

  ld bc,$0808

  xor a

  CALL_(DisplayAcids)  

  ld d,0

  

WaitKey:

  halt

  call GET_KEY

  or a

  jr z,WaitKey

  cp K_EXIT

  ret z
  jr nz,PageDown



Output:

  CALL_(DisplayAcids)

  pop de

  jr WaitKey





PageDown:

  ld hl,$FC80

  ld bc,$380

  push de

  CALL_(Clear)

  pop de

  ld bc,$0808

  ld a,(NoAcids)

  sub d

  cp 9

  jr nc,NextPage

  ld d,-8  

NextPage:

  ld a,d

  add a,8

  ld d,a

  push de  

  jr Output

  

Clear:  

  ld e,l

  ld d,h

  inc de

  ld (hl),0

  ldir

  ret

   

; Display B acids, starting with acid A from row C

DisplayAcids:

  ld de,Acids

  ld hl,(PROGRAM_ADDR)

  add hl,de

  ;add a,a

  jr z,DispLoop

  push bc

  ld b,a

  xor a

  ; Search in acid list

Search:

  ld c,-1

  cpir  

  djnz Search

  pop bc

  ; B = acids left to display, C = current row, HL -> Acid, DE = $8333  

DispLoop:

  ld a,(hl)

  or a

  ret z   ; Check if no more acids

  ld a,c  

  ld ($8334),a

  add a,7

  ld c,a  

  ld a,1

  ld ($8333),a

  ROM_CALL(D_ZM_STR)

  

  djnz DispLoop

  ret

  

Header:

 .db "WILLIAMIV@GEOCITIES.COM",0

Acids:
 .db "LAWS OF EXPONENTS",0

 .db "(a^x)*(a^y) = a^(x+y)",0
 .db "(a^x)/(a^y) = a^(x-y)",0
 .db "(a^x)^y = a^(x*y)",0
 .db "a^(1/2) = ",$10,"a",0
 .db "a^(x/y) = y",$CD,$10,"(a^x)",0
 .db "(a/b)^x = (a^x)/(b^x)",0
 .db "a^-x = 1/(a^x)",0
 .db "(a*b*c)^x = a^x*b^x*c^x",0
 .db "(a+b+c)^x  =/=  "
 .db "a^x+b^x+c^x !!!",0
 .db "a^0 = 1,  a=/=0",0
 .db "Arithmetic Operations",0
 .db "a(b+c) = ab+ac",0
 .db "-(a+b+c) = -a-b-c",0
 .db "(a+b)/c = a/c+b/c",0
 .db "c/(a+b)  =/=  c/a+c/b !!!",0
 .db "(a/b)/(c/d) = "
 .db "(a/b)*(d/c) = ad/bc",0
 .db "1/(a-b) = -1/(b-a)",0
 .db "(a*b*c)/d = a*b(c/d)",0
 .db "a/b+c/d = (ad+bc)/bd",0
 .db "LOGARITHMS",0
 .db "y = log x MEANS ",$1D,"^y = x",0
 .db "y = ln x MEANS e^y = x",0
 .db "log (x*y) = log x+log y",0
 .db "log (x/y) = log x-log y",0
 .db "log (x^r) = r*log x",0
 .db "10^log x = x; e^ln x = x",0
 .db "log(10^x) = x; ln(e^x) = x",0
 .db "log 10 = 1; ln e = 1",0
 .db "log 1 = 0; ln 1 = 0",0
 .db "ln x = log x/log e",0
 .db " ",0
 .db "EQUATIONS",0
 .db "IF A+B=C & D+E=F",0
 .db "& K=some constant",0
 .db "THEN",0
 .db "A+B+K=C+K",0
 .db "A+B-K=C-K",0
 .db "(A+B)*K=C*K",0
 .db "(A+B)/K=C/K",0
 .db "A+B+D+E=C+F",0
 .db "A+B-D-E=C-F",0
 .db "(A+B)*(D+E)=C*F",0
 .db "(A+B)/(D+E)=C/F",0
 .db "1/(A+B)=1/C",0
 .db "1/(D+E)=1/F",0
 .db " ",0
 .db " ",0
 .db "GRAPHS",0
 .db "y = M*x+b",0
 .db "y-Y1 = M(x-X1)",0
 .db "(X1,Y1) is PT 1   "
 .db "(X2,Y2) is PT 2",0
 .db "M = (Y2-Y1)/(X2-X1)",0
 .db "D = ",$10,"( (X2-X1)",$12,
 .db " + (Y2-Y1)",$12," )",0
 .db "Ax+By = C",0
 .db "M = -A/B & b = C/B",0
 .db "QUADRATIC EQUATION",0
 .db "Ax",$12,"+Bx+C=0",0
 .db "        -B+/-"
 .db $10,"(B",$12,"-4AC)",0
 .db "x = -----------",0
 .db "                 2A",0
 .db "GEOMETRY",0
 .db "CIRCLE",0
 .db "A=",$C4,"r"
 .db $12,"   C=2",$C4,"r",0
 .db "SPHERE",0
 .db "V=4/3 ",$C4,"r^3"
 .db "  SA=4",$C4,"r",$12,0
 .db "CYLINDER",0
 .db "V=",$C4,"r",$12,"h"
 .db "  L.SA=2",$C4,"rh",0
 .db "CONE",0
 .db "V=1/3 ",$C4,"r",$12,"h",0
 .db "SA=",$C4,"r*",$10
 .db "(r",$12,"+h",$12,")",0
 .db " ",0
 .db "TRAPAZOID",0
 .db "A=1/2 h(b1+b2)",0
 .db "TRIGONOMETRY",0
 .db $BE,"ABC  w/  ",$13
 .db "s  ",$BB,$BC,$BD,0
 .db "A=1/2 bh;   C=a+b+c",0
 .db "A=1/2 AB*sin",$BD,0
 .db "IF ",$BD,"=90"
 .db " [RT ",$BE,"]",0
 .db "C",$12,"=A",$12,"+B",$12,0
 .db "LAW OF COSINES",0
 .db "A",$12,"=B"
 .db $12,"+C",$12
 .db "-2B*Ccos ",$BB,0
 .db "B",$12,"=A"
 .db $12,"+C",$12
 .db "-2A*Ccos ",$BC,0
 .db "C",$12,"=A"
 .db $12,"+B",$12
 .db "-2A*Bcos ",$BD,0
 .db "LAW OF SINES",0
 .db "sin ",$BB
 .db " = sin ",$BC
 .db " = sin ",$BD,0
 .db "----      "
 .db "----     ----",0
 .db "       a"
 .db "         "
 .db "         b"
 .db "           "
 .db "      c",0
 .db "IDENTITIES",0
 .db "sin",$12,$C1
 .db " + cos",$12,$C1,"=1",0
 .db "1 + cot",$12
 .db $C1,"=csc",$12,$C1,0
 .db "tan",$12,$C1
 .db " + 1=sec",$12,$C1,0
 .db "sin(2",$C1,") = 2sin"
 .db $C1,"cos",$C1,0
 .db "cos(2",$C1,") = cos"
 .db $12,$C1,"-sin",$12,$C1,0
 .db "tan(2",$C1,") = (2tan"
 .db $C1,")/(1-tan",$12,$C1,")",0
 .db "sin",$12,$C1
 .db " = 1/2 - 1/2 cos (2",$C1,")",0
 .db "cos",$12,$C1
 .db " = 1/2 + 1/2 cos (2",$C1,")",0
 .db "tan",$12,$C1," = (1-cos (2",$C1
 .db "))/(1+cos (2",$C1,"))",0
 .db 0   ; End of acids



 .end

 
